/*-
 * Copyright (C)2005 @BABOLO http://www.babolo.ru/
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
 *  OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
 * IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
 * INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
 * (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

#define Sa 0x00000001 /* (segment->index >= indx)                                */
#define Ss 0x00000002 /* (segment->index < idx->index)     */
#define Se 0x00000004 /* (segment->index == idx->index)       */
#define Si 0x00000008 /* (segmin <= indx)                                        */
#define Sr 0x00000010 /* (res)                                      */
#define Sx 0x00000020 /* (segi < SIZE(level))                    */
#define So 0x00000040 /* (indx <= idx->index)                                    */
#define S_full   0x3F

#define Cp 0x00800000 /*         */
#define Cr 0x00400000 /*   mular_get */
#define Cs 0x00200000 /*     */
#define Cd 0x00100000 /*  mular_dub           */
#define Cy 0x00080000 /*       */
#define Ci 0x00040000 /*           */
#define Ce 0x00020000 /*              */
#define C_state  0xFF /*            */

enum states {d0, de, dx};
/* d0 -   
   de -  
   dx - 
 */
static const u_int32_t automa[S_full + 1][dx] =
/*        d0        de */
{ {   Cd| dx,   Cd| dx} /*      */
, {   Cd| dx,   Cd| dx} /*     a*/
, {Ce   | dx,Ce   | dx} /*    s */
, {Ce   | dx,Ce   | dx} /*    sa*/
, {Ce   | dx,Ce   | dx} /*   e  */
, {Ce   | dx,Ce   | dx} /*   e a*/
, {Ce   | dx,Ce   | dx} /*   es */
, {Ce   | dx,Ce   | dx} /*   esa*/
, {   Cd| dx,   Cd| dx} /*  i   */
, {   Cd| dx,   Cd| dx} /*  i  a*/
, {Ce   | dx,Ce   | dx} /*  i s */
, {Ce   | dx,Ce   | dx} /*  i sa*/
, {Ce   | dx,Ce   | dx} /*  ie  */
, {Ce   | dx,Ce   | dx} /*  ie a*/
, {Ce   | dx,Ce   | dx} /*  ies */
, {Ce   | dx,Ce   | dx} /*  iesa*/
, {   Cy| dx,   Cy| dx} /* r    */
, {   Cy| dx,   Cy| dx} /* r   a*/
, {Ce   | dx,Ce   | dx} /* r  s */
, {Ce   | dx,Ce   | dx} /* r  sa*/
, {Ce   | dx,Ce   | dx} /* r e  */
, {Ce   | dx,Ce   | dx} /* r e a*/
, {Ce   | dx,Ce   | dx} /* r es */
, {Ce   | dx,Ce   | dx} /* r esa*/
, {   Cy| dx,   Cy| dx} /* ri   */
, {   Cy| dx,   Cy| dx} /* ri  a*/
, {Ce   | dx,Ce   | dx} /* ri s */
, {Ce   | dx,Ce   | dx} /* ri sa*/
, {Ce   | dx,Ce   | dx} /* rie  */
, {Ce   | dx,Ce   | dx} /* rie a*/
, {Ce   | dx,Ce   | dx} /* ries */
, {Ce   | dx,Ce   | dx} /* riesa*/
, {Cp|Ci| de,   Cd| dx} /*x     */
, {   Ci| de,   Cd| dx} /*x    a*/
, {   Ci| d0,   Cd| dx} /*x   s */
, {   Ci| d0,   Cd| dx} /*x   sa*/
, {   Ci| de,   Cd| dx} /*x  e  */
, {   Ci| de,   Cd| dx} /*x  e a*/
, {Ce   | dx,Ce   | dx} /*x  es */
, {Ce   | dx,Ce   | dx} /*x  esa*/
, {Cp|Ci| de,   Cd| dx} /*x i   */
, {Cr|Ci| de,   Cd| dx} /*x i  a*/
, {   Ci| d0,   Cd| dx} /*x i s */
, {Cr|Ci| d0,   Cd| dx} /*x i sa*/
, {   Ci| de,   Cd| dx} /*x ie  */
, {Cr|Ci| de,   Cd| dx} /*x ie a*/
, {Ce   | dx,Ce   | dx} /*x ies */
, {Ce   | dx,Ce   | dx} /*x iesa*/
, {Cp|Ci| de,   Cy| dx} /*xr    */
, {Cs|Ci| de,   Cy| dx} /*xr   a*/
, {   Ci| d0,   Cy| dx} /*xr  s */
, {Cs|Ci| d0,   Cy| dx} /*xr  sa*/
, {   Ci| de,   Cy| dx} /*xr e  */
, {Cs|Ci| de,   Cy| dx} /*xr e a*/
, {Ce   | dx,Ce   | dx} /*xr es */
, {Ce   | dx,Ce   | dx} /*xr esa*/
, {Cp|Ci| de,   Cy| dx} /*xri   */
, {Cs|Ci| de,   Cy| dx} /*xri  a*/
, {   Ci| d0,   Cy| dx} /*xri s */
, {Cs|Ci| d0,   Cy| dx} /*xri sa*/
, {   Ci| de,   Cy| dx} /*xrie  */
, {Cs|Ci| de,   Cy| dx} /*xrie a*/
, {Ce   | dx,Ce   | dx} /*xries */
, {Ce   | dx,Ce   | dx} /*xriesa*/
};
